Index: src/web100-util.c
===================================================================
--- src/web100-util.c	(revision 796)
+++ src/web100-util.c	(working copy)
@@ -17,6 +17,61 @@
 #include "protocol.h"
 #include "strlutils.h"
 
+struct tcp_name {
+  char* web100_name;
+  char* web10g_name;
+};
+
+/* Must match in-order with tcp_vars in web100srv.h struct */
+static struct tcp_name tcp_names[] = {
+/* {"WEB100", "WEB10G" } / tcp_vars name / */
+  {"Timeouts", "Timeouts"}, /* Timeouts */
+  {"SumRTT", "SumRTT"}, /* SumRTT */
+  {"CountRTT", "CountRTT"}, /* CountRTT */
+  {"PktsRetrans", "SegsRetrans"}, /* PktsRetrans */
+  {"FastRetran", "FastRetran"}, /* FastRetran */
+  {"DataPktsOut", "DataSegsOut"}, /* DataPktsOut */
+  {"AckPktsOut", NULL}, /* AckPktsOut - not included in web10g */
+  {"CurMSS", "CurMSS"}, /* CurrentMSS */
+  {"DupAcksIn", "DupAcksIn"}, /* DupAcksIn */
+  /* NOTE: in the server to client throughput test all packets received from client are ack's 
+   * So SegsIn == AckPktsIn. I don't see a replacement in web10g maybe (SegsIn - DataSegsIn)
+   */
+  {"AckPktsIn", "SegsIn"}, /* AckPktsIn - not included in web10g */
+  {"MaxRwinRcvd", "MaxRwinRcvd"}, /* MaxRwinRcvd */
+  {"X_Sndbuf", NULL}, /* Sndbuf - Not in Web10g pull from socket */
+  {"CurCwnd", "CurCwnd"}, /* CurrentCwnd */
+  {"SndLimTimeRwin", "SndLimTimeRwin"}, /* SndLimTimeRwin */
+  {"SndLimTimeCwnd", "SndLimTimeCwnd"}, /* SndLimTimeCwnd */
+  {"SndLimTimeSender", "SndLimTimeSnd"}, /* SndLimTimeSender */
+  {"DataBytesOut", "DataOctetsOut"}, /* DataBytesOut */
+  {"SndLimTransRwin", "SndLimTransRwin"}, /* SndLimTransRwin */
+  {"SndLimTransCwnd", "SndLimTransCwnd"}, /* SndLimTransCwnd */
+  {"SndLimTransSender", "SndLimTransSnd"}, /* SndLimTransSender */
+  {"MaxSsthresh", "MaxSsthresh"}, /* MaxSsthresh */
+  {"CurRTO", "CurRTO"}, /* CurrentRTO */
+  {"CurRwinRcvd", "CurRwinRcvd"}, /* CurrentRwinRcvd */
+  {"MaxCwnd", NULL}, /* MaxCwnd split into MaxSsCwnd and MaxCaCwnd web10g */
+  {"CongestionSignals", "CongSignals"}, /* CongestionSignals */
+  {"PktsOut", "SegsOut"}, /* PktsOut */
+  {"MinRTT", "MinRTT"}, /* MinRTT */
+  {"RcvWinScale", "WinScaleRcvd"}, /* RcvWinScale */
+  {"SndWinScale", "WinScaleSent"}, /* SndWinScale */
+  {"CongAvoid", "CongAvoid"}, /* CongAvoid */
+  {"CongestionOverCount", "CongOverCount"}, /* CongestionOverCount */
+  {"MaxRTT", "MaxRTT"}, /* MaxRTT */
+  {"OtherReductions", "OtherReductions"}, /* OtherReductions */
+  {"CurTimeoutCount", "CurTimeoutCount"}, /* CurTimeoutCount */
+  {"AbruptTimeouts", "AbruptTimeouts"}, /* AbruptTimeouts */
+  {"SendStall", "SendStall"}, /* SendStall */
+  {"SlowStart", "SlowStart"}, /* SlowStart */
+  {"SubsequentTimeouts", "SubsequentTimeouts"}, /* SubsequentTimeouts */
+  {"ThruBytesAcked", "ThruOctetsAcked"}, /* ThruBytesAcked */
+  { NULL, "MaxSsCwnd" }, /* MaxSsCwnd */
+  { NULL, "MaxCaCwnd" } /* MaxCaCwnd */
+};
+
+
 /**
  * set up the necessary structures for monitoring connections at the
  * beginning
@@ -24,7 +79,8 @@
  * @return integer indicating number of web100 variables read
  * 		or indicating failure of initialization
  */
-int web100_init(char *VarFileName) {
+int tcp_stat_init(char *VarFileName) {
+#ifdef FORCE_WEB100
   FILE * fp;
   char line[256], trimmedline[256];
   int count_vars = 0;
@@ -54,9 +110,59 @@
   log_println(1, "web100_init() read %d variables from file", count_vars);
 
   return (count_vars);
+
+#else /* Must be web10g */
+  // Web100 would have setup a table of string's with the variable names 
+  // loaded from an external file
+  // We already have one of these setup for us in the library itself.
+  // So we do nothing
+  return TOTAL_INDEX_MAX;
+#endif
 }
 
 /**
+ * Get a string representation of an ip address.
+ * 
+ * @param addr A sockaddr structure which contains the address
+ * @param buf A buffer to fill with the ip address as a string
+ * @param len The length of buf.
+ */
+static void addr2a(struct sockaddr_storage * addr,char * buf, int len){
+  if(((struct sockaddr *)addr)->sa_family == AF_INET){
+    /* IPv4 */
+    inet_ntop(AF_INET, &(((struct sockaddr_in *)addr)->sin_addr),
+                    buf, len);
+  }
+#ifdef AF_INET6 
+  else if(((struct sockaddr *)addr)->sa_family == AF_INET6 ){
+    /* IPv6 */
+    inet_ntop(AF_INET6, &(((struct sockaddr_in6 *)addr)->sin6_addr),
+                    buf, len);
+  }
+#endif
+}
+
+/**
+ * Get a string representation of an port number.
+ * 
+ * @param addr A sockaddr structure which contains the port number
+ * @param buf A buffer to fill with the port number as a string
+ * @param len The length of buf.
+ */
+static void port2a(struct sockaddr_storage * addr,char * buf, int len){
+  if(((struct sockaddr *)addr)->sa_family == AF_INET){
+    /* IPv4 */
+    snprintf(buf, len, "%hu", ntohs(((struct sockaddr_in *)addr)->sin_port));
+  }
+#ifdef AF_INET6 
+  else if(((struct sockaddr *)addr)->sa_family == AF_INET6 ){
+    /* IPv6 */
+    snprintf(buf, len, "%hu", ntohs(((struct sockaddr_in6 *)addr)->sin6_port));
+  }
+#endif
+}
+
+/**
  * Performs part of the middlebox test.
  * The server sets the maximum value of the
  * congestion window, and starts a 5 second long
@@ -74,11 +180,19 @@
  *
  *
  */
-void web100_middlebox(int sock, web100_agent* agent, web100_connection* cn,
+
+void tcp_stat_middlebox(int sock, tcp_stat_agent agent, tcp_stat_connection cn,
                       char *results, size_t results_strlen) {
+#ifdef FORCE_WEB100
   web100_var* var;
   web100_group* group;
   web100_snapshot* snap;
+  web100_var *LimCwnd;
+#else /* Must be web10g */
+  struct tcpe_val value;
+  tcpe_data * data = NULL;
+#endif
+
   char buff[8192], line[256];
   char* sndbuff;
   int i, j, k, currentMSSval = 0;
@@ -88,12 +202,16 @@
   int ret;
   char tmpstr[200];
   size_t tmpstrlen = sizeof(tmpstr);
-  I2Addr addr = NULL;
-  web100_var *LimCwnd;
   u_int32_t limcwnd_val;
+  struct sockaddr_storage saddr;
+  socklen_t saddr_size;
 
   // middlebox test results
+#ifdef FORCE_WEB100
   static char vars[][255] = { "CurMSS", "WinScaleSent", "WinScaleRecv", };
+#else
+  static char vars[][255] = { "CurMSS", "WinScaleSent", "WinScaleRcvd", };
+#endif
 
   assert(results);
 
@@ -101,16 +219,24 @@
 
   // get Server address and add to "results"
 
-  // get socket name
-  addr = I2AddrByLocalSockFD(get_errhandle(), sock, False);
-  memset(tmpstr, 0, 200);
-  // copy address into tmpstr String
-  I2AddrNodeName(addr, tmpstr, &tmpstrlen);
-  // now copy tmpstr containing address into "line"
-  snprintf(line, sizeof(line), "%s;", tmpstr);
-  memset(tmpstr, 0, 200);
-  // service name into tmpstr
-  I2AddrServName(addr, tmpstr, &tmpstrlen);
+  // get socket IP address
+  saddr_size = sizeof(saddr);
+  if (getsockname(sock,(struct sockaddr *) &saddr, &saddr_size) == -1) {
+    /* Make it clear something failed but continue test */
+    log_println(0,"Middlebox - getsockname() failed: %s", strerror(errno));
+    snprintf(line, sizeof(line), "address_error;");
+    snprintf(tmpstr, sizeof(tmpstr), "0");
+  } else {
+    // copy address into tmpstr String
+    memset(tmpstr, 0, 200);
+    addr2a(&saddr, tmpstr , tmpstrlen);
+    // now copy tmpstr containing address into "line"
+    snprintf(line, sizeof(line), "%s;", tmpstr);
+    memset(tmpstr, 0, 200);
+    // service name into tmpstr
+    tmpstrlen = sizeof(tmpstr);
+    port2a(&saddr, tmpstr, tmpstrlen);
+  }
   log_print(3, "Server: %s%s ", line, tmpstr);
   // copy servers address into the meta test struct
   memcpy(meta.server_ip, line, strlen(line));
@@ -118,27 +244,35 @@
   meta.server_ip[(strlen(line) - 1)] = 0;
   // Add this address to results
   strlcat(results, line, results_strlen);
-  I2AddrFree(addr);  // free memory
 
   // Now perform the above set of functions for client address/service name
   // and copy into results
   tmpstrlen = sizeof(tmpstr);
-  addr = I2AddrBySockFD(get_errhandle(), sock, False);
-  memset(tmpstr, 0, 200);
-  I2AddrNodeName(addr, tmpstr, &tmpstrlen);
-  snprintf(line, sizeof(line), "%s;", tmpstr);
-  I2AddrServName(addr, tmpstr, &tmpstrlen);
+  saddr_size = sizeof(saddr);
+  if (getpeername(sock,(struct sockaddr *) &saddr, &saddr_size) == -1) {
+    /* Make it clear something failed but continue test */
+    log_println(0,"Middlebox - getpeername() failed: %s", strerror(errno));
+    snprintf(line, sizeof(line), "address_error;");
+    snprintf(tmpstr, sizeof(tmpstr), "0");
+  } else {
+  // copy address into tmpstr String
+    memset(tmpstr, 0, 200);
+    addr2a(&saddr, tmpstr , tmpstrlen);
+    snprintf(line, sizeof(line), "%s;", tmpstr);
+    tmpstrlen = sizeof(tmpstr);
+    port2a(&saddr, tmpstr, tmpstrlen);
+  }
+  
   log_print(3, "Client: %s%s ", line, tmpstr);
   strlcat(results, line, results_strlen);
-  I2AddrFree(addr);
 
   // get web100 values for the middlebox test result group
   for (i = 0; i < 3; i++) {
+#ifdef FORCE_WEB100
     // read web100_group and web100_var of vars[i] into group and var
     web100_agent_find_var_and_group(agent, vars[i], &group, &var);
     // read variable value from web100 connection
     web100_raw_read(var, cn, buff);
-
     // get current MSS in textual format and append to results
 
     // get current MSS value and append to "results"
@@ -147,6 +281,14 @@
           web100_value_to_text(web100_get_var_type(var), buff));
     snprintf(line, sizeof(line), "%s;",
              web100_value_to_text(web100_get_var_type(var), buff));
+#else /* Must be web10g */
+    // read a web10g value
+    web10g_get_val(agent, cn, vars[i], &value);
+    if (strcmp(vars[i], "CurMSS") == 0)
+      currentMSSval = value.uv32;
+    snprintf(line, sizeof(line), "%u;", value.uv32);
+#endif 
+
     if (strcmp(line, "4294967295;") == 0)
       snprintf(line, sizeof(line), "%d;", -1);
 
@@ -165,12 +307,15 @@
    * RAC 2/28/06
    */
 
+  // set TCP CWND web100 variable to twice the current MSS Value
+  limcwnd_val = 2 * currentMSSval;
+#ifdef FORCE_WEB100
   // get web100_var and web100_group
   web100_agent_find_var_and_group(agent, "LimCwnd", &group, &LimCwnd);
-
-  // set TCP CWND web100 variable to twice the current MSS Value
-  limcwnd_val = 2 * currentMSSval;
   web100_raw_write(LimCwnd, cn, &limcwnd_val);
+#else
+  tcpe_write_var("LimCwnd", (uint32_t)limcwnd_val, cn, agent);
+#endif
   log_println(5, "Setting Cwnd Limit to %d octets", limcwnd_val);
 
   // try to allocate memory of the size of current MSS Value
@@ -194,9 +339,14 @@
     sndbuff[j] = (k++ & 0x7f);
   }
 
+#ifdef FORCE_WEB100
   // get web100 group with name "read"
   group = web100_group_find(agent, "read");
   snap = web100_snapshot_alloc(group, cn);
+#else
+  // Allocating memory
+  tcpe_data_new(&data);
+#endif
 
   FD_ZERO(&wfd);
   FD_SET(sock, &wfd);
@@ -205,7 +355,7 @@
   while ((ret = select(sock + 1, NULL, &wfd, NULL, &sel_tv)) > 0) {
     if ((ret == -1) && (errno == EINTR)) /* a signal arrived, ignore it */
       continue;
-
+#ifdef  FORCE_WEB100
     web100_snap(snap);
 
     // get next sequence # to be sent
@@ -216,7 +366,16 @@
     web100_agent_find_var_and_group(agent, "SndUna", &group, &var);
     web100_snap_read(var, snap, line);
     SndUna = atoi(web100_value_to_text(web100_get_var_type(var), line));
-
+#else /* Must be web10g */
+    // Grab the current snap of this
+    tcpe_read_vars(data, cn, agent);
+    // get next sequence # to be sent
+    web10g_find_val(data, "SndNxt", &value);
+    SndMax = value.uv32;
+    // get oldest un-acked sequence number
+    web10g_find_val(data, "SndUna", &value);
+    SndUna = value.uv32;
+#endif
     // stop sending data if (buf size * 16) <
     // [ (Next Sequence # To Be Sent) - (Oldest Unacknowledged Sequence #) - 1 ]
     if ((currentMSSval << 4) < (SndMax - SndUna - 1)) {
@@ -231,9 +390,16 @@
     if (k < 0)  // general error writing to socket. quit
       break;
   }
+
+#ifdef FORCE_WEB100
   log_println(5, "Finished with web100_middlebox() routine snap-0x%x, "
               "sndbuff=%x0x", snap, sndbuff);
   web100_snapshot_free(snap);
+#else
+  tcpe_data_free(&data);
+  log_println(5, "Finished with web10g_middlebox() routine "
+              "sndbuff=%x0x", sndbuff);
+#endif
   /* free(sndbuff); */
 }
 
@@ -246,12 +412,18 @@
  * @param count_vars integer number of web100_variables to get value of
  *
  */
-void web100_get_data_recv(int sock, web100_agent* agent, web100_connection* cn,
+
+void tcp_stat_get_data_recv(int sock, tcp_stat_agent agent, tcp_stat_connection cn,
                           int count_vars) {
+#ifdef FORCE_WEB100
+  web100_var* var;
+  web100_group* group;
+#else
+  tcpe_data* data = NULL;
+#endif
+
   int i, ok;
-  web100_var* var;
   char buf[32], line[256], *ctime();
-  web100_group* group;
   FILE * fp;
   time_t tt;
 
@@ -263,10 +435,15 @@
     fprintf(fp, "%15.15s;", ctime(&tt) + 4);
   // get values for group, var of IP Address of the Remote host's side of
   // connection
+#ifdef FORCE_WEB100
   web100_agent_find_var_and_group(agent, "RemAddress", &group, &var);
   web100_raw_read(var, cn, buf);
   snprintf(line, sizeof(line), "%s;",
            web100_value_to_text(web100_get_var_type(var), buf));
+#else /* web10g */
+  web10g_get_remote_addr(agent, cn, buf, sizeof(buf));
+  snprintf(line, sizeof(line), "%s;", buf);
+#endif
   // write remote address to log file
   if (fp)
     fprintf(fp, "%s", line);
@@ -274,7 +451,7 @@
   ok = 1;
 
   // get values for other web100 variables and write to the log file
-
+#ifdef FORCE_WEB100
   for (i = 0; i < count_vars; i++) {
     if ((web100_agent_find_var_and_group(agent, web_vars[i].name, &group,
                                          &var)) != WEB100_ERR_SUCCESS) {
@@ -305,7 +482,46 @@
     }
     ok = 1;
   }
+#else /* web10g */
+  tcpe_data_new(&data);
+  tcpe_read_vars(data, cn, agent) ;
 
+  //Loop through all the web10g variables and write to file/log_print them
+  for(i = 0; i < ARRAYSIZE(data->val); i++) {
+    if (data->val[i].mask) continue;
+
+    switch(tcpe_var_array[i].type) {
+      case TCPE_UNSIGNED64:
+        if (fp)
+          fprintf(fp, "%" PRIu64 ";", data->val[i].uv64 );
+        log_println(9, "%s: %" PRIu64 "", tcpe_var_array[i].name, data->val[i].uv64 );
+        break;
+      case TCPE_UNSIGNED32:
+        if (fp)
+          fprintf(fp, "%u;", data->val[i].uv32 );
+        log_println(9, "%s: %u", tcpe_var_array[i].name, data->val[i].uv32 );
+        break;
+      case TCPE_SIGNED32:
+        if (fp)
+          fprintf(fp, "%d;", data->val[i].sv32 );
+        log_println(9, "%s: %d", tcpe_var_array[i].name, data->val[i].sv32 );
+        break;
+      case TCPE_UNSIGNED16:
+        if (fp)
+          fprintf(fp, "%" PRIu16 ";", data->val[i].uv16 );
+        log_println(9, "%s: %" PRIu16 "", tcpe_var_array[i].name, data->val[i].uv16);
+        break;
+      case TCPE_UNSIGNED8:
+        if (fp)
+          fprintf(fp, "%" PRIu8 ";", data->val[i].uv8 );
+        log_println(9, "%s: %" PRIu8 "", tcpe_var_array[i].name, data->val[i].uv8);
+        break;
+      default:
+        break;
+    }
+  }  
+  tcpe_data_free(&data);
+#endif
   // close file pointers after web100 variables have been fetched
   if (fp) {
     fprintf(fp, "\n");
@@ -313,6 +529,13 @@
   }
 }
 
+#ifndef FORCE_WEB100
+/* Persistent storage is needed. Replacment for web100 web_vars not very nice TODO */
+static tcpe_data* dataDumpSave;
+static int X_Sndbuf;
+static int X_Rcvbuf;
+#endif
+
 /**
  * Collect Web100 stats from a snapshot and transmit to a receiver.
  * The transmission is done using a TES_MSG type message and sent to
@@ -324,8 +547,9 @@
  * @param count_vars integer number of web100_variables to get value of
  *
  */
-int web100_get_data(web100_snapshot* snap, int ctlsock, web100_agent* agent,
+int tcp_stat_get_data(tcp_stat_snap snap, int testsock, int ctlsock, tcp_stat_agent agent,
                     int count_vars) {
+#ifdef FORCE_WEB100
   int i;
   web100_var* var;
   char buf[32], line[256];
@@ -371,8 +595,170 @@
   }
   log_println(6, "S2C test - Send web100 data to client pid=%d", getpid());
   return (0);
+#else /* web10g */
+  int j;
+  char  line[256];
+  unsigned int m;
+  struct tcpe_val val;
+  
+  m = sizeof(X_Rcvbuf);
+  getsockopt(testsock, SOL_SOCKET, SO_RCVBUF, (void *)&X_Rcvbuf, &m);
+  m = sizeof(X_Sndbuf);
+  getsockopt(testsock, SOL_SOCKET, SO_SNDBUF, (void *)&X_Sndbuf, &m);
+  
+  assert(snap);
+  
+  tcpe_data_new(&dataDumpSave);
+
+  for(j = 0; j < ARRAYSIZE(snap->val); j++) {
+    dataDumpSave->val[j].mask = snap->val[j].mask;
+    dataDumpSave->val[j].uv64 = snap->val[j].uv64;
+    if (snap->val[j].mask) continue;
+
+    switch(tcpe_var_array[j].type) {
+      case TCPE_UNSIGNED64:
+        snprintf(line, sizeof(line), "%s: %" PRIu64 "\n", 
+                 tcpe_var_array[j].name, snap->val[j].uv64);
+        break;
+      case TCPE_UNSIGNED32:
+        snprintf(line, sizeof(line), "%s: %u\n", 
+                 tcpe_var_array[j].name, snap->val[j].uv32 );
+        break;
+      case TCPE_SIGNED32:
+        snprintf(line, sizeof(line), "%s: %d\n", 
+                 tcpe_var_array[j].name, snap->val[j].sv32 );
+        break;
+      case TCPE_UNSIGNED16:
+        snprintf(line, sizeof(line), "%s: %" PRIu16 "\n", 
+                 tcpe_var_array[j].name, snap->val[j].uv16);
+      case TCPE_UNSIGNED8:
+        snprintf(line, sizeof(line), "%s: %" PRIu8 "\n", 
+                 tcpe_var_array[j].name, snap->val[j].uv8);
+        break;
+      default:
+        break;
+    }
+    send_msg(ctlsock, TEST_MSG, line, strlen(line));
+    log_print(9, "%s", line);
+  }
+  
+  /* This is the list of changed variable names that the client tries to read.
+   * Web100 -> Web10g
+   * ECNEnabled -> ECN
+   * NagleEnabled -> Nagle
+   * SACKEnabled -> WillSendSACK & WillUseSACK
+   * TimestampsEnabled -> TimeStamps
+   * PktsRetrans -> SegsRetrans
+   * X_Rcvbuf -> Not in web10g doesn't acutally use it so just leave it out
+   * DataPktsOut -> DataSegsOut
+   * AckPktsOut -> Depreciated
+   * MaxCwnd -> MaxSsCwnd MaxCaCwnd
+   * SndLimTimeSender -> SndLimTimeSnd
+   * DataBytesOut -> DataOctetsOut
+   * AckPktsIn -> Depreciated
+   * SndLimTransSender -> SndLimTransSnd
+   * PktsOut -> SegsOut
+   * CongestionSignals -> CongSignals
+   * RcvWinScale -> Same as WinScaleSent if WinScaleSent != -1
+   */
+  send_msg(ctlsock, TEST_MSG, "-~~~Web100_old_var_names~~~-: 1\n", strlen("-~~~Web100_old_var_names~~~-: 1\n"));
+  uint32_t temp;
+  
+  /* ECNEnabled -> ECN */
+  val.uv64 = 0;
+  web10g_find_val(snap, "ECN", &val);
+  snprintf(line, sizeof(line), "ECNEnabled: %d\n", val.sv32);
+  send_msg(ctlsock, TEST_MSG, line, strlen(line));
+  
+  /* NagleEnabled -> Nagle */
+  val.uv64 = 0;
+  web10g_find_val(snap, "Nagle", &val);
+  snprintf(line, sizeof(line), "NagleEnabled: %d\n", val.sv32);
+  send_msg(ctlsock, TEST_MSG, line, strlen(line));
+  
+  /* SACKEnabled -> WillUseSACK & WillSendSACK 
+   * keep this in line with web100 for now i.e. 0 == off 1 == on */
+  val.uv64 = 0;
+  web10g_find_val(snap, "WillUseSACK", &val);
+  snprintf(line, sizeof(line), "SACKEnabled: %d\n", (val.sv32 == 1) ? 1 : 0);
+  send_msg(ctlsock, TEST_MSG, line, strlen(line));
+  
+  /* TimestampsEnabled -> TimeStamps */
+  val.uv64 = 0;
+  web10g_find_val(snap, "TimeStamps", &val);
+  snprintf(line, sizeof(line), "TimestampsEnabled: %d\n", val.sv32);
+  send_msg(ctlsock, TEST_MSG, line, strlen(line));
+  
+  /* PktsRetrans -> SegsRetrans */
+  val.uv64 = 0;
+  web10g_find_val(snap, "SegsRetrans", &val);
+  snprintf(line, sizeof(line), "PktsRetrans: %u\n", val.uv32);
+  send_msg(ctlsock, TEST_MSG, line, strlen(line));
+
+  /* DataPktsOut -> DataSegsOut */
+  val.uv64 = 0;
+  web10g_find_val(snap, "DataSegsOut", &val);
+  snprintf(line, sizeof(line), "DataPktsOut: %u\n", val.uv32);
+  send_msg(ctlsock, TEST_MSG, line, strlen(line));
+  
+  /* MaxCwnd -> MaxSsCwnd MaxCaCwnd */
+  val.uv64 = 0;
+  web10g_find_val(snap, "MaxSsCwnd", &val);
+  temp = val.uv32;
+  val.uv64 = 0;
+  web10g_find_val(snap, "MaxCaCwnd", &val);
+  temp = MAX(temp, val.uv32); 
+  snprintf(line, sizeof(line), "DataPktsOut: %u\n", temp);
+  send_msg(ctlsock, TEST_MSG, line, strlen(line));
+  
+  /* SndLimTimeSender -> SndLimTimeSnd */
+  val.uv64 = 0;
+  web10g_find_val(snap, "SndLimTimeSnd", &val);
+  snprintf(line, sizeof(line), "SndLimTimeSender: %u\n", val.uv32); 
+  send_msg(ctlsock, TEST_MSG, line, strlen(line));
+  
+  /* DataBytesOut -> DataOctetsOut */
+  val.uv64 = 0;
+  web10g_find_val(snap, "DataOctetsOut", &val);
+  snprintf(line, sizeof(line), "DataBytesOut: %u\n", val.uv32); 
+  send_msg(ctlsock, TEST_MSG, line, strlen(line));
+  
+  /* SndLimTransSender -> SndLimTransSnd */
+  val.uv64 = 0;
+  web10g_find_val(snap, "SndLimTransSnd", &val);
+  snprintf(line, sizeof(line), "SndLimTransSender: %u\n", val.uv32); 
+  send_msg(ctlsock, TEST_MSG, line, strlen(line));
+  
+  /* PktsOut -> SegsOut */
+  val.uv64 = 0;
+  web10g_find_val(snap, "SegsOut", &val);
+  snprintf(line, sizeof(line), "PktsOut: %u\n", val.uv32); 
+  send_msg(ctlsock, TEST_MSG, line, strlen(line));
+  
+  /* CongestionSignals -> CongSignals */
+  val.uv64 = 0;
+  web10g_find_val(snap, "CongSignals", &val);
+  snprintf(line, sizeof(line), "CongestionSignals: %u\n", val.uv32); 
+  send_msg(ctlsock, TEST_MSG, line, strlen(line));
+  
+  /* RcvWinScale -> Same as WinScaleSent if WinScaleSent != -1 */
+  val.uv64 = 0;
+  web10g_find_val(snap, "WinScaleSent", &val);
+  if( val.sv32 == -1)
+    snprintf(line, sizeof(line), "RcvWinScale: %u\n", 0); 
+  else
+    snprintf(line, sizeof(line), "RcvWinScale: %d\n", val.sv32); 
+  send_msg(ctlsock, TEST_MSG, line, strlen(line));
+ 
+  send_msg(ctlsock, TEST_MSG, "-~~~Web100_old_var_names~~~-: 1\n", strlen("-~~~Web100_old_var_names~~~-: 1\n"));
+  
+  log_println(6, "S2C test - Send web100 data to client pid=%d", getpid());
+  return 0;
+#endif
 }
 
+
+#ifdef FORCE_WEB100
 /**
  * Calculate Web100 based Round-Trip Time (RTT) value.
  *
@@ -417,7 +803,9 @@
   sum = atoi(web100_value_to_text(web100_get_var_type(var), buf));
   return (sum / count);
 }
+#endif /* Appears to be unused so no need for web10g version */
 
+
 /**
  * Check if the "Auto Tune Send Buffer" and "Auto Tune Receive Buffer" options
  * are enabled and return status on each
@@ -434,8 +822,8 @@
  * 					22 Cannot find X_SBufMode or X_RBufMode web100_variable's var/group.
  * 					23 cannot read the value of the X_SBufMode or X_RBufMode web100_variable.
  */
-
-int web100_autotune(int sock, web100_agent* agent, web100_connection* cn) {
+int tcp_stat_autotune(int sock, tcp_stat_agent agent, tcp_stat_connection cn) {
+#ifdef FORCE_WEB100
   web100_var* var;
   char buf[32];
   web100_group* group;
@@ -476,8 +864,13 @@
   if (i == 0)
     j |= 0x02;
   return (j);
+#else /* web10g */
+  return 0x03; /* Disabled, well web10g doesn't autotune the kernel does though */
+#endif
 }
 
+
+#ifdef FORCE_WEB100
 /**
  * Check if the "Auto Tune Send Buffer" and "Auto Tune Receive Buffer" options
  * are enabled. If not, scale the Send window or receive window sizes based on the
@@ -501,7 +894,7 @@
  * 					35 - cannot read value of RcvWinScale web100 variable.
  *
  */
-int web100_setbuff(int sock, web100_agent* agent, web100_connection* cn,
+int tcp_stat_setbuff(int sock, tcp_stat_agent agent, tcp_stat_connection cn,
                    int autotune) {
   web100_var* var;
   char buf[32];
@@ -566,114 +959,81 @@
 
   return (0);
 }
+#endif /* Not used so don't need to make web10g version */
 
 /**
- * @param sock integer socket file descriptor indicating data recipient
- * @param pointers to local copies of web100 variables
+ * @param tcp_vars to local copies of web100 variables
+ * @param count_vars the number of web100 vars loaded
  * @return integer 0
  *
- *
  */
-int web100_logvars(int *Timeouts, int *SumRTT, int *CountRTT, int *PktsRetrans,
-                   int *FastRetran, int *DataPktsOut, int *AckPktsOut,
-                   int *CurrentMSS, int *DupAcksIn, int *AckPktsIn,
-                   int *MaxRwinRcvd, int *Sndbuf, int *CurrentCwnd,
-                   int *SndLimTimeRwin, int *SndLimTimeCwnd,
-                   int *SndLimTimeSender, int *DataBytesOut,
-                   int *SndLimTransRwin, int *SndLimTransCwnd,
-                   int *SndLimTransSender, int *MaxSsthresh, int *CurrentRTO,
-                   int *CurrentRwinRcvd, int *MaxCwnd, int *CongestionSignals,
-                   int *PktsOut, int *MinRTT, int count_vars, int *RcvWinScale,
-                   int *SndWinScale, int *CongAvoid, int *CongestionOverCount,
-                   int *MaxRTT, int *OtherReductions, int *CurTimeoutCount,
-                   int *AbruptTimeouts, int *SendStall, int *SlowStart,
-                   int *SubsequentTimeouts, int *ThruBytesAcked) {
-  int i;
+int tcp_stat_logvars(struct tcp_vars * vars, int count_vars)
+{
+#ifdef FORCE_WEB100
+  int a,b;
+  
+  for (a = 0; a < (sizeof(struct tcp_vars) / sizeof(tcp_stat_var)); a++) {
+    if(tcp_names[a].web100_name == NULL)
+      break;
+      
+    /* Find the corresponding value */
+    for (b = 0; ;b++){
+      if(b == (count_vars + 1)){
+        log_println(1,"WARNING: Couldn't Find web100 var %s", tcp_names[a].web100_name);
+        break;
+      }
+      if(strcmp(web_vars[b].name, tcp_names[a].web100_name) == 0){
+        ((tcp_stat_var *) vars)[a] = atoi(web_vars[b].value);
+        log_println(5, "Found %s : %i", tcp_names[a].web100_name, ((tcp_stat_var *) vars)[a]);
+        break;
+      }
+      
+    }
 
-  for (i = 0; i <= count_vars; i++) {
-    if (strcmp(web_vars[i].name, "Timeouts") == 0)
-      *Timeouts = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SumRTT") == 0)
-      *SumRTT = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CountRTT") == 0)
-      *CountRTT = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "PktsRetrans") == 0)
-      *PktsRetrans = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "FastRetran") == 0)
-      *FastRetran = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "DataPktsOut") == 0)
-      *DataPktsOut = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "AckPktsOut") == 0)
-      *AckPktsOut = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CurMSS") == 0)
-      *CurrentMSS = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "DupAcksIn") == 0)
-      *DupAcksIn = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "AckPktsIn") == 0)
-      *AckPktsIn = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "MaxRwinRcvd") == 0)
-      *MaxRwinRcvd = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "X_Sndbuf") == 0)
-      *Sndbuf = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CurCwnd") == 0)
-      *CurrentCwnd = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "MaxCwnd") == 0)
-      *MaxCwnd = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SndLimTimeRwin") == 0)
-      *SndLimTimeRwin = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SndLimTimeCwnd") == 0)
-      *SndLimTimeCwnd = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SndLimTimeSender") == 0)
-      *SndLimTimeSender = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "DataBytesOut") == 0)
-      *DataBytesOut = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SndLimTransRwin") == 0)
-      *SndLimTransRwin = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SndLimTransCwnd") == 0)
-      *SndLimTransCwnd = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SndLimTransSender") == 0)
-      *SndLimTransSender = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "MaxSsthresh") == 0)
-      *MaxSsthresh = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CurRTO") == 0)
-      *CurrentRTO = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CurRwinRcvd") == 0)
-      *CurrentRwinRcvd = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CongestionSignals") == 0)
-      *CongestionSignals = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "PktsOut") == 0)
-      *PktsOut = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "MinRTT") == 0)
-      *MinRTT = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "RcvWinScale") == 0)
-      *RcvWinScale = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SndWinScale") == 0)
-      *SndWinScale = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CongAvoid") == 0)
-      *CongAvoid = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CongestionOverCount") == 0)
-      *CongestionOverCount = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "MaxRTT") == 0)
-      *MaxRTT = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "OtherReductions") == 0)
-      *OtherReductions = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CurTimeoutCount") == 0)
-      *CurTimeoutCount = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "AbruptTimeouts") == 0)
-      *AbruptTimeouts = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SendStall") == 0)
-      *SendStall = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SlowStart") == 0)
-      *SlowStart = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SubsequentTimeouts") == 0)
-      *SubsequentTimeouts = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "ThruBytesAcked") == 0)
-      *ThruBytesAcked = atoi(web_vars[i].value);
   }
+  return 0;
+#else /* web10g */
+  int a,b;
+  
+  /* Set it to zero so we know what we are comparing to later */
+  vars->MaxCwnd = 0;
+  
+  for (a = 0; a < (sizeof(struct tcp_vars) / sizeof(tcp_stat_var)); a++) {
+    if(tcp_names[a].web10g_name == NULL)
+      continue;
+    
+    /* Find the corresponding value */
+    for (b = 0; ; b++){
+      if(b == ARRAYSIZE(dataDumpSave->val)){
+        log_println(1, "WARNING: Couldn't Find web10g var %s", tcp_names[a].web10g_name);
+        break;
+      }
 
-  return (0);
+      if (dataDumpSave->val[b].mask) continue;
+      if(strcmp(tcpe_var_array[b].name, tcp_names[a].web10g_name) == 0){
+        ((tcp_stat_var *) vars)[a] = dataDumpSave->val[b].uv32;
+        log_println(5, "Found %s : %i", tcp_names[a].web10g_name, ((tcp_stat_var *) vars)[a]);
+        break;
+      }
+    }
+
+  }
+  
+  /* Now lets deal to those things which are no longer in web10g */
+  vars->AckPktsOut = 0;
+  vars->Sndbuf = X_Sndbuf;
+  vars->MaxCwnd = MAX(vars->MaxSsCwnd,vars->MaxCaCwnd);
+  
+  /* Free the data */
+  tcpe_data_free(&dataDumpSave);
+  dataDumpSave = NULL;
+  return 0;
+#endif
 }
 
+
+ 
+#ifdef FORCE_WEB100
 /**
  * Routine to read snaplog file and determine the number of times the
  * congestion window is reduced.
@@ -687,7 +1047,7 @@
  * @return Integer, 0 on success, -1 on failure
  */
 
-int CwndDecrease(web100_agent* agent, char* logname, u_int32_t *dec_cnt,
+int CwndDecrease(tcp_stat_agent agent, char* logname, u_int32_t *dec_cnt,
                  u_int32_t *same_cnt, u_int32_t *inc_cnt) {
   web100_var* var;
   char buff[256];
@@ -751,7 +1111,9 @@
       *inc_cnt, *dec_cnt, *same_cnt);
   return (0);
 }
+#endif /* web10g TODO when logging is do-able*/
 
+#ifdef FORCE_WEB100
 /**
  * Generate TCP/IP checksum for our packet
  *
@@ -939,3 +1301,4 @@
     return (-1);
   return (0);
 }
+#endif
